// http://fr.openclassrooms.com/informatique/cours/programmez-avec-le-langage-c/les-structures-de-controle-4
#include <iostream>
#include <iomanip>      // std::setprecision
#include <cmath>
// c.f. http://www.cplusplus.com/reference/cmath/
#include <string.h>

#include <stdlib.h> // pour random  : rand(...)
// c.f. http://www.cplusplus.com/reference/cstdlib/rand/

// Opérateurs : c.f. http://www.cplusplus.com/doc/tutorial/operators/
//  +  -  *  /      %  = modulo
using namespace std;

int version_1()
//=============
// Le but est de convertir des nombres à virgule flottante
// codé en de binaire 32 bits en nombre à virugle
// Traite plusieurs nombres et
// traites les espaces dans les données.
{
char acNb2[255]; // nombre en binaire, sous forme de chaine de caractères
float vNb10 = 0; // le nombre en base 10
float nSign = 1; // le signe
char  cSign = '+';
float nExposant = 0;
float vMantisse = 1.0;
float vPow2 = 1.0; // puissance de 2, exposants négatifs
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

string astrNb2[20];
astrNb2[ 1] = "0 01111111 00000000000000000000000";  // a = 1
astrNb2[ 2] = "0 10000010 10100000000000000000000";  // b = 13
astrNb2[ 3] = "0 01111110 01000000000000000000000";  // c = 0.625
astrNb2[ 4] = "0 01111011 10011001100110011001100";  // d = 0.1
astrNb2[ 5] = "0 10000011 00010000000000000000000";  // e = 17
astrNb2[ 6] = "0 01111101 01000000000000000000000";  // f = 0.3125
astrNb2[ 7] = "0 01111111 10011001100110011001100";  // g = 1.6
astrNb2[ 8] = "0 01111101 00110011001100110011001";  // h = 0.3
astrNb2[ 9] = "0 10000000 10010010000111111011010";  // i = 3.14159
astrNb2[10] = "0 10000000 01011011111100001010100";  // j = 2.71828
astrNb2[11] = "0 01111111 01101010000010011110011";  // k = 1.41421
astrNb2[12] = "0 01111111 10011110001101110111100";  // l = 1.61803
astrNb2[13] = "1 01111111 10000000000000000000000";  // m =-1.5

cout << "Conversion de nombres à virgule en binaire 32 bits." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le code 32 bits du nombre : ";
   cin.getline(acNb2,256);  // met toute la ligne dans acNb2

   if (acNb2[0] == 0) return 0; // car rien de tapé.

   // si on a tapé une lettre, utilise la chaine prédéfinie
   if ((acNb2[0] >= 'a') && (acNb2[0] <= 'm')) {
     strcpy(acNb2, astrNb2[acNb2[0] - 'a' + 1].c_str());
     cout << acNb2 << endl;
     }

   nInd = 0;
   vNb10 = 0;
   // Cherche le signe du nombre
   while ((acNb2[nInd] > 0) && (acNb2[nInd] != '0' ) &&
          (acNb2[nInd] != '1' )) nInd++;

   if (acNb2[nInd] == 0) return 0; // car nombre mal tapé
   if (acNb2[nInd] == '0') { nSign = 1; cSign = '+'; }
   else                    { nSign =-1; cSign = '-'; }
   nInd++;

   // Définition de l'exposant
   nn = 0; // Compte le nombre de bits de l'exposant
   nExposant = 0;
   while (nn < 8) {
     // saute les espaces et autres caractères non significatifs
     while ((acNb2[nInd] > 0) && (acNb2[nInd] != '0' ) &&
            (acNb2[nInd] != '1' )) nInd++;

     if (acNb2[nInd] == 0) return 0; // car nombre mal tapé

     if (acNb2[nInd] == '1') nExposant = nExposant * 2 + 1;
     if (acNb2[nInd] == '0') nExposant = nExposant * 2;

     nInd++;
     nn++;
     }

   nInd++;
   nExposant = nExposant - 127;

   // Définition de la mantisse
   nn = 0; // Compte le nombre de bits de l'exposant
   vMantisse = 1.0;
   vPow2 = 1.0;
   while ((nn < 23) && (acNb2[nInd] > 0 )) {
     // saute les espaces et autres caractères non significatifs
     while ((acNb2[nInd] > 0) && (acNb2[nInd] != '0' ) &&
            (acNb2[nInd] != '1' )) nInd++;

     vPow2 = vPow2 / 2;
     if (acNb2[nInd] == '1') vMantisse = vMantisse + vPow2;

     nInd++;
     nn++;
     }

   vNb10 = nSign * vMantisse * exp2(nExposant);

   cout << "Signe, exposant, mantisse = " << cSign << "  " << nExposant << "  " << vMantisse << endl;
   cout << setprecision(9); // défini la précision d'affichage des nombres
   cout << "Le nombre vaut : " << vNb10 << endl;
   cout << setprecision(6); // défini la précision d'affichage des nombres
   cout << "Le nombre vaut : " << vNb10 << endl << endl;
   // c.f. http://www.cplusplus.com/reference/iomanip/setprecision/
   }
} // version_1

int version_2()
//=============
// Le but est de convertir des nombres à virgule flottante
// de nombre à virgule en nombre codé en de binaire 32 bits
// Traite plusieurs nombres et
// traites les espaces dans les données.
{
//char acNb2[255]; // nombre en binaire, sous forme de chaine de caractères
string strNb2 = "";
float vNb10 = 0; // le nombre en base 10
float nSign = 1; // le signe
char  cSign = '+';
float nExposant = 0;
float vMantisse = 1.0;
float vPow2 = 1.0; // puissance de 2, exposants négatifs
int nInd = 0;  // pour parcourir les chiffres binaires
int nn = 0; // pour des boucles

cout << "Conversion de nombres à virgule en binaire 32 bits." << endl;
cout << "Les caractères autres que '0' et '1' seront ignorés." << endl;

while (true) {
   cout << "Tapez le nombre à virgule : ";
   cin >> vNb10;

   if (vNb10 == 0) {
     cout << "Le code binaire vaut : " << "0 00000000 00000000000000000000000" << endl;
     return 0;  // termine
     }

   if (vNb10 < 0) {
     strNb2 = "1 ";
     vNb10 = -vNb10;
     }
   else { strNb2 = "0 "; }

   // défini l'exposant
   nExposant = 127;
   while (vNb10 < 1) {
     nExposant = nExposant - 1;
     vNb10 *= 2;
     }

   while (vNb10 >= 2) {
     nExposant = nExposant + 1;
     vNb10 /= 2;
     }

   // Convertit l'exposant en binaire
   for (nn=1; nn<=8; nn++) {
     if (nExposant > 127) { strNb2 = strNb2 + "1"; nExposant -= 128; }
     else                 { strNb2 = strNb2 + "0"; }
     nExposant *= 2;
     }

   // convertit la mantisse
   strNb2 = strNb2 + " "; // le premier chiffre de la mantisse est implicitement égale à 1
   vNb10 = (vNb10 - 1) * 2;
   for (nn=1; nn<=23; nn++) {
     if (vNb10 >= 1) { strNb2 = strNb2 + "1"; vNb10 -= 1; }
     else            { strNb2 = strNb2 + "0"; }
     vNb10 *= 2;
     }

   cout << "Le code binaire vaut : " << strNb2 << endl << endl;
   }
} // version_2

int main()
//========
{
version_1();
}
